package net.parsell.cherry.core;

import net.fabricmc.fabric.api.client.rendering.v1.ColorProviderRegistry;
import net.fabricmc.fabric.api.item.v1.FabricItemSettings;
import net.minecraft.block.Block;
import net.minecraft.item.BlockItem;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.SignItem;
import net.minecraft.util.Identifier;
import net.minecraft.util.registry.Registry;

public class CherryItems {
	public static final BlockItem CherryPlanks;

	private static void registerBlockItems(){
		registerBlockItem("cherry_log", CherryBlocks.CHERRYLOG, CherryRegistry.CHERRY_GROUP);
		registerBlockItem("cherry_wood", CherryBlocks.CHERRYWOOD, CherryRegistry.CHERRY_GROUP);
		registerBlockItem("stripped_cherry_log", CherryBlocks.CHERRYLOGSTRIPPED, CherryRegistry.CHERRY_GROUP);
		registerBlockItem("stripped_cherry_wood", CherryBlocks.CHERRYWOODSTRIPPED, CherryRegistry.CHERRY_GROUP);
		registerBlockItem("cherry_leaves", CherryBlocks.CHERRYLEAVES, CherryRegistry.CHERRY_GROUP, 6649929);
		registerBlockItem("cherry_fence", CherryBlocks.CHERRYFENCE, CherryRegistry.CHERRY_GROUP);
		registerBlockItem("cherry_fence_gate", CherryBlocks.CHERRYFENCEGATE, CherryRegistry.CHERRY_GROUP);
		registerBlockItem("cherry_door", CherryBlocks.CHERRYDOOR, CherryRegistry.CHERRY_GROUP);
		registerBlockItem("cherry_trapdoor", CherryBlocks.CHERRYTRAPDOOR, CherryRegistry.CHERRY_GROUP);
		registerBlockItem("cherry_slab", CherryBlocks.CHERRYSLAB, CherryRegistry.CHERRY_GROUP);
		registerBlockItem("cherry_stairs", CherryBlocks.CHERRYSTAIRS, CherryRegistry.CHERRY_GROUP);
		registerBlockItem("cherry_button", CherryBlocks.CHERRYBUTTON, CherryRegistry.CHERRY_GROUP);
		registerBlockItem("cherry_pressure_plate", CherryBlocks.CHERRYPRESSUREPLATE, CherryRegistry.CHERRY_GROUP);
		registerSignItem("cherry_sign", CherryBlocks.CHERRYSIGN, CherryBlocks.CHERRYSIGN, CherryRegistry.CHERRY_GROUP);
	}

	// Register a standard blockItem
	private static BlockItem registerBlockItem(String itemID, Block block, ItemGroup group){
		BlockItem blockItem = new BlockItem(block, new FabricItemSettings().group(group));
		Registry.register(Registry.ITEM, new Identifier("cherry", itemID), blockItem);
		return blockItem;
	}

	// Register a blockItem that require in-game color (leaves)
	private static void registerBlockItem(String itemID, Block block, ItemGroup group, int color){
		BlockItem blockItem = new BlockItem(block, new FabricItemSettings().group(group));
		Registry.register(Registry.ITEM, new Identifier("cherry", itemID), blockItem);
		ColorProviderRegistry.ITEM.register((stack, tintIndex) -> {
			return color;
		 }, block
		);
	}

	private static void registerSignItem(String itemID, Block standingBlock, Block wallBlock, ItemGroup group) {
		Registry.register(Registry.ITEM, new Identifier("cherry", itemID), new SignItem(new FabricItemSettings().group(group), standingBlock, wallBlock));
	}

	public static void init(){
		System.out.println("Cherry Items initilizating...");
		registerBlockItems();
		System.out.println("Cherry Items setup correctly!");
	}

	static{
		CherryPlanks = registerBlockItem("cherry_planks", CherryBlocks.CHERRYPLANKS, CherryRegistry.CHERRY_GROUP);
	}
}
